//THIS FILE CONTAINS MAIN CONTROL FUNCTIONS

#include <iostream>
#include <cstring>
#include <cstdlib>
#include <cmath>

int a=255;
char filename[200];
char shortname[50];
int intensity[257];
int picture_height;
int picture_width;
float magnification =1.0;
int *xcoord;
int *ycoord;

int height2, width2;
long int fluor2;
int file_index;
int click_times;
int max_pix_value;
int color_click=0;
int color_click2=1;
int color_click3=0;

int cluster_on = 0;
int stepOK;
int whichRadioChosen;
int size_limit=0;
int negative_mode=0;


QList<double> Value_list; QList<int> Pos_list;
QList<double> Value_list2; QList<int> Pos_list2;

int fwidth; int fheight;
int xmargin, xmargin2, ymargin;
double pixPerX, pixPerY;
double GLOBAL_pixPerX, GLOBAL_pixPerY;
int GLOBAL_minX, GLOBAL_maxX;
double minY, maxY, realMaxY=0.0;
int minX=-1, maxX, realMinX=0, realMaxX=0;

int line=0, stripes=0;
int globaldisplay=1, globaltimes=0;
int selected_chromosome=-1;

QFile errorfile;
QTextStream error_stream;

QVector<int> Start_index, End_index, Start_value, End_value, Color_value;
QStringList Tag;

/////////////////////////////////////////////////
QPixmap MyWidget::plot0(QList<int> Pos_l, QList<double> Value_l, int N)
{
  int i;
  QPixmap map(fwidth,fheight);
  
  map.fill(Qt::white);
  QPainter p(&map);
  QPen pen;
  pen = p.pen();
  pen.setWidth(2);
  p.setPen(pen);

if(stripes)
{
int line_y1, line_y2;
pen.setColor(QColor(25,180,25)); p.setPen(pen);
line_y1 = (int)( fheight-ymargin-(int)((7.3-minY)*pixPerY));
p.drawLine(0,line_y1,fwidth,line_y1);
p.drawText(0, 0, fwidth, line_y1, Qt::AlignBottom | Qt::AlignLeft, "7.3");  
		   
pen.setColor(QColor(140,140,140)); p.setPen(pen);
line_y1 = (int)( fheight-ymargin-(int)((6-minY)*pixPerY));
p.drawLine(0,line_y1,fwidth,line_y1); 
p.drawText(0, 0, fwidth, line_y1, Qt::AlignBottom | Qt::AlignLeft, "6");  

pen.setColor(QColor(170,170,170)); p.setPen(pen);
line_y1 = (int)( fheight-ymargin-(int)((5-minY)*pixPerY));
p.drawLine(0,line_y1,fwidth,line_y1);
p.drawText(0, 0, fwidth, line_y1, Qt::AlignBottom | Qt::AlignLeft, "5");  

pen.setColor(QColor(200,200,200)); p.setPen(pen);
line_y1 = (int)( fheight-ymargin-(int)((4-minY)*pixPerY));
p.drawLine(0,line_y1,fwidth,line_y1);
p.drawText(0, 0, fwidth, line_y1, Qt::AlignBottom | Qt::AlignLeft, "4");  

pen.setColor(QColor(230,230,230)); p.setPen(pen);
line_y1 = (int)( fheight-ymargin-(int)((3-minY)*pixPerY));
p.drawLine(0,line_y1,fwidth,line_y1);
p.drawText(0, 0, fwidth, line_y1, Qt::AlignBottom | Qt::AlignLeft, "3");  
}

pen.setWidth(2);

bool ok1, ok2;
int startred=0;
int endred=0;

  
  int xp0=0, xp1=0, xp2=0;
  
  int color=255;
  int position=0, oldposition=0;
  QString TagEntry="", OldTagEntry=Tag.at(0);
  
  for(i=0; i<N;i++)
  {
    
    double value = Value_l.at(i);
    position=Pos_l.at(i);

    int xp = (int)( (double)(position-minX) * pixPerX);
    int yp = (int)( fheight-ymargin-(int)((value-minY)*pixPerY));
    
    if(i==0) {xp0=xp; xp1=xp; xp2=xp;}
    else {xp1=xp2; xp2=xp;}
    
    int arrayloc=Start_value.size()-1;
  
    
    while(arrayloc>0)
    {
      
      if(position>=Start_value.at(arrayloc)) 
      {
	color=Color_value.at(arrayloc); break;
      }
      arrayloc-=1;
    }
    
    TagEntry = Tag.at(arrayloc);
    if(TagEntry!=OldTagEntry)
    {  
    QFont myFont2("Calibri", 10, QFont::Normal); p.setFont(myFont2);
    p.drawText(xp0, 0, (xp1-xp0), fheight, Qt::AlignBottom | Qt::AlignCenter, OldTagEntry);
    xp0=xp;
    }
    OldTagEntry=TagEntry;	
        
    pen.setColor(QColor(color,50,50)); p.setPen(pen);
    p.drawPoint(xp,yp);
    
  }
  
  p.drawText(xp0, 0, (xp1-xp0), fheight, Qt::AlignBottom | Qt::AlignCenter, TagEntry);

                   QString Title=shortname;
                   Title=Title + ", max(-logP)=" + QString::number(realMaxY);
                   pen.setColor(QColor(0,0,0)); p.setPen(pen);
                   
                   QFont myFont("Calibri", 12, QFont::Normal); p.setFont(myFont);
                   p.drawText(0, 0, fwidth, 20, Qt::AlignCenter | Qt::AlignVCenter, Title);
		   
globaldisplay=1;
return map;
}

/////////////////////////////////////
QPixmap MyWidget::plot(QList<int> Pos_l, QList<double> Value_l, int N)
{
  int i;
  QPixmap map(fwidth,fheight);
 
  map.fill(Qt::white);
  QPainter p(&map);
  QPen pen;
  pen = p.pen();
  pen.setWidth(2);
  p.setPen(pen);

if(stripes)
{
int line_y1, line_y2;
pen.setColor(QColor(25,180,25)); p.setPen(pen);
line_y1 = (int)( fheight-ymargin-(int)((7.3-minY)*pixPerY));
p.drawLine(0,line_y1,fwidth,line_y1);
p.drawText(0, 0, fwidth, line_y1, Qt::AlignBottom | Qt::AlignLeft, "7.3");  
		   
pen.setColor(QColor(140,140,140)); p.setPen(pen);
line_y1 = (int)( fheight-ymargin-(int)((6-minY)*pixPerY));
p.drawLine(0,line_y1,fwidth,line_y1); 
p.drawText(0, 0, fwidth, line_y1, Qt::AlignBottom | Qt::AlignLeft, "6");  

pen.setColor(QColor(170,170,170)); p.setPen(pen);
line_y1 = (int)( fheight-ymargin-(int)((5-minY)*pixPerY));
p.drawLine(0,line_y1,fwidth,line_y1);
p.drawText(0, 0, fwidth, line_y1, Qt::AlignBottom | Qt::AlignLeft, "5");  

pen.setColor(QColor(200,200,200)); p.setPen(pen);
line_y1 = (int)( fheight-ymargin-(int)((4-minY)*pixPerY));
p.drawLine(0,line_y1,fwidth,line_y1);
p.drawText(0, 0, fwidth, line_y1, Qt::AlignBottom | Qt::AlignLeft, "4");  

pen.setColor(QColor(230,230,230)); p.setPen(pen);
line_y1 = (int)( fheight-ymargin-(int)((3-minY)*pixPerY));
p.drawLine(0,line_y1,fwidth,line_y1);
p.drawText(0, 0, fwidth, line_y1, Qt::AlignBottom | Qt::AlignLeft, "3");  
}

pen.setWidth(4);

bool ok1, ok2;
int startred=0;
int endred=0;

QString StartRed = startEdit->text();
QString EndRed = endEdit->text();

QStringList StartList = StartRed.split("-");

if(StartList.size()==2)
{
  startred = StartList.at(0).toInt(&ok1);
  endred = StartList.at(1).toInt(&ok2);
}
else
{  
  startred = StartRed.toInt(&ok1);
  endred = EndRed.toInt(&ok2);
}
if(!ok1 || !ok2) {startred=0; endred=0;}  


pen.setColor(QColor(50,50,255)); p.setPen(pen);

  if(line==0)
  {  
  for(i=0; i<N;i++)
  {
    
    if(Pos_l.at(i)>=startred && Pos_l.at(i)<=endred) {pen.setColor(QColor(255,50,50)); p.setPen(pen);}
    else {pen.setColor(QColor(50,50,255)); p.setPen(pen);}
    
    double value = Value_l.at(i);
    int xp = (int)( (double)(Pos_l.at(i)-minX) * pixPerX);
    int yp = (int)( fheight-ymargin-(int)((value-minY)*pixPerY));
    p.drawPoint(xp,yp);
  }
  }
  
  else
  {  
  for(i=1; i<N;i++)
  {
    
    if(Pos_l.at(i)>=startred && Pos_l.at(i)<=endred) {pen.setColor(QColor(255,50,50)); p.setPen(pen);}
    else {pen.setColor(QColor(50,50,255)); p.setPen(pen);}
    
    double value1 = Value_l.at(i-1);
    int xp1 = (int)( (double)(Pos_l.at(i-1)-minX) * pixPerX);
    int yp1 = (int)( fheight-ymargin-(int)((value1-minY)*pixPerY));
    
    double value2 = Value_l.at(i);
    int xp2 = (int)( (double)(Pos_l.at(i)-minX) * pixPerX);
    int yp2 = (int)( fheight-ymargin-(int)((value2-minY)*pixPerY));
    p.drawLine(xp1,yp1,xp2,yp2);
   }
   }
 
                   int counter;
                   pen.setColor(QColor(0,0,0)); p.setPen(pen);           
		   
		   QString Title = "max=" + QString::number(realMaxY);

                   QFont myFont("Calibri", 12, QFont::Normal); p.setFont(myFont);
                   p.drawText(0, 0, fwidth, 20, Qt::AlignCenter | Qt::AlignVCenter, Title);

		   
		   QString MINX=QString::number(realMinX);
		   QString MAXX=QString::number(realMaxX);
		   QString DELTA=QString::number(realMaxX-realMinX);
		   
		   QString MINX2;
		   counter=0;
		   for(i=MINX.size()-1; i>=0; i--)
		   {
		     counter+=1; MINX2.prepend(MINX.at(i));
		     if(counter==3 && i>0) {MINX2.prepend(","); counter=0;}
		     
		   }
		   
                   QString MAXX2;
		   counter=0;
		   for(i=MAXX.size()-1; i>=0; i--)
		   {
		     counter+=1; MAXX2.prepend(MAXX.at(i));
		     if(counter==3 && i>0) {MAXX2.prepend(","); counter=0;}
		     
		   }
		   
		   QString DELTA2;
		   counter=0;
		   for(i=DELTA.size()-1; i>=0; i--)
		   {
		     counter+=1; DELTA2.prepend(DELTA.at(i));
		     if(counter==3 && i>0) {DELTA2.prepend(","); counter=0;}
		     
		   }
		   
		   
		   DELTA2 = "|<-- " +  DELTA2 + " -->|";
		   
                   QFont myFont1("Calibri", 10, QFont::Normal); p.setFont(myFont1);
		   
                   p.drawText(0, 0, fwidth, fheight-2, Qt::AlignBottom | Qt::AlignLeft, MINX2);   
                   p.drawText(0, 0, fwidth, fheight-2, Qt::AlignBottom | Qt::AlignRight, MAXX2);
                   p.drawText(0, 0, fwidth, fheight-2, Qt::AlignBottom | Qt::AlignCenter, DELTA2);

return map;
}

////////////////////////////////////FULL MANHATTAN
void MyWidget::getManhattan0()
{

int f, i, pos=0, oldpos=0;
double value=0.0, oldvalue=0.0;
QString oneRow,oldID, Header;
QStringList list1;
bool ok;
QString Missing ="NA";

int column = 3;
int idcolumn = 1;
int divvalue = 100;
int poscolumn=2;
QString Delim="\t";
int xcounter=0, ycounter=-1;
int headeryes=1;

QFile infile(filename); if(!infile.open(QIODevice::ReadOnly | QIODevice::Text)) {error_stream <<"Cannot open data file!"<<"\n"; exit(1);}
QTextStream in_stream(&infile);


if(!in_stream.atEnd()) 
{
   Header = in_stream.readLine();
   if(Header.contains("\t")) Delim="\t";
   else if(Header.contains(" ")) Delim=" ";
   else if(Header.contains(",")) Delim=",";
   else {error_stream <<"Unknown data file delimiter!"<<"\n"; exit(1);}

   list1=Header.split(Delim); if(list1.size()<3) {error_stream <<"Data file contains < 3 columns!"<<"\n"; exit(1);}
   
   for(i=0; i<list1.size(); i++)
   {
     int number=0;
     int intv=list1.at(i).toInt(&ok); if(ok) number+=1;
     double doublev=list1.at(i).toDouble(&ok); if(ok) number+=1;
     if(number<1){headeryes=1; break;}
     else headeryes=0;
   }   
   
in_stream.seek(0);  
}


//analyze header
if(!in_stream.atEnd() && headeryes==1) 
{
  Header = in_stream.readLine();
  list1=Header.split(Delim);
  
   for(i=0; i<list1.size(); i++)
   {
     if(list1.at(i).contains("pos", Qt::CaseInsensitive)){poscolumn=i+1; break;}
     else poscolumn=-1;
   }
  
   for(i=0; i<list1.size(); i++)
   {
     if(list1.at(i).contains("pval", Qt::CaseInsensitive)){column=i+1; break;}
     else if(list1.at(i).contains("p-val", Qt::CaseInsensitive)){column=i+1; break;}
     else if(list1.at(i) == "P" || list1.at(i) == "p"){column=i+1; break;}
     else column=-1;
   }
   
   for(i=0; i<list1.size(); i++)
   {
     if(list1.at(i).contains("chr", Qt::CaseInsensitive)){idcolumn=i+1; break;}
     else if(list1.at(i).contains("some", Qt::CaseInsensitive)){idcolumn=i+1; break;}
     else if(list1.at(i).contains("id", Qt::CaseInsensitive)){idcolumn=i+1; break;}
     else idcolumn=-1;
   }
   
   
   if(poscolumn<1 || column<1 || idcolumn<1) {error_stream <<"Incorrect data columns!"<<"\n"; exit(1);}
   
}
else {idcolumn=1; poscolumn=2; column=3;}


QString odID="-", ID, Value, Pos;
QStringList ID_list;

Value_list.clear(); Pos_list.clear();

//read values
int scannedrows=0, chromcounter=0;
while(!in_stream.atEnd())
{
oneRow = in_stream.readLine(); 

if(!oneRow.isEmpty())
{
  list1=oneRow.split(Delim);  
  Value=list1.at(column-1); Pos=list1.at(poscolumn-1); ID=list1.at(idcolumn-1);
  
  if(Value!=Missing)
  {
    value = Value.toDouble(&ok); if(!ok) {error_stream <<"Non-numeric p-value detected!"<<"\n"; exit(1);}
    if(value!=0.0)
    {
         
	 
         ID_list.append(ID);//ID not needed
         value=-log10(value); 
	 Value_list.append(value);
                 pos=Pos.toInt(&ok); if(!ok) {error_stream <<"Non-integer position value detected!"<<"\n"; exit(1);}
		 pos/=divvalue;//divide positions
		 Pos_list.append(pos);


	if(oldID!=ID && scannedrows>0)
	{
	   End_index.append(ID_list.size()-1); Start_index.append(ID_list.size());
	   End_value.append(oldpos); Start_value.append(pos);
	   Tag.append(oldID);
	   
	        if(Color_value.size()==0)Color_value.append(255);
		else
		{
		  if(Color_value.at(Color_value.size()-1) == 255) Color_value.append(50);
		  else Color_value.append(255);
		}
	}
	
	else if(scannedrows==0)
	{
	  Start_index.append(0);
	  Start_value.append(pos);
	  scannedrows=1;
	}
	
        else ;

    oldID=ID; oldpos=pos; oldvalue=value;
    }
    
  }
}
}

           End_index.append(ID_list.size()-1);
	   End_value.append(oldpos);
	   Tag.append(oldID);
	   
	        if(Color_value.size()==0)Color_value.append(255);
		else
		{
		  if(Color_value.at(Color_value.size()-1) == 255) Color_value.append(50);
		  else Color_value.append(255);
		}


oldID=ID_list.at(0); oldpos=Pos_list.at(0); int previous=0;

for(i=0; i<Pos_list.size(); i++)
{
  if(oldID==ID_list.at(i))
  {
  Pos_list[i]=Pos_list.at(i)-oldpos+1+previous;
  }
  
  else
  {
    oldID=ID_list.at(i); oldpos=Pos_list.at(i);
    previous=Pos_list.at(i-1);
    
    Pos_list[i]=Pos_list.at(i)-oldpos+1+previous;
  }
  
}
     

for(i=0; i<Start_value.size(); i++)
{
  Start_value[i]=Pos_list.at(Start_index.at(i));
  End_value[i]=Pos_list.at(End_index.at(i));
}
     


if(ID_list.size()<2) {error_stream <<"Illegal data range in getManhattan0!"<<"\n"; exit(1);}

Pos_list2=Pos_list;
Value_list2=Value_list;

ID_list.clear();

}

////////////////////////////////////
void MyWidget::getManhattan()
{

int f, i, pos, oldpos;
double value;
QString oneRow,oldID, Header;
QStringList list1;
bool ok;
QString Missing ="NA";
int column = 3;
int idcolumn = 1;
int divvalue = 10;
int poscolumn=2;
QString Delim="\t";
int xcounter=0, ycounter=-1;
int headeryes=1;

QFile infile(filename); if(!infile.open(QIODevice::ReadOnly | QIODevice::Text)) {error_stream <<"Cannot open data file!"<<"\n"; exit(1);}
QTextStream in_stream(&infile);


if(!in_stream.atEnd()) 
{
   Header = in_stream.readLine();
   if(Header.contains("\t")) Delim="\t";
   else if(Header.contains(" ")) Delim=" ";
   else if(Header.contains(",")) Delim=",";
   else {error_stream <<"Unknown data file delimiter!"<<"\n"; exit(1);}

   list1=Header.split(Delim); if(list1.size()<3) {error_stream <<"Data file contains < 3 columns!"<<"\n"; exit(1);}
   
   for(i=0; i<list1.size(); i++)
   {
     int number=0;
     int intv=list1.at(i).toInt(&ok); if(ok) number+=1;
     double doublev=list1.at(i).toDouble(&ok); if(ok) number+=1;
     if(number<1){headeryes=1; break;}
     else headeryes=0;
   }   

in_stream.seek(0);  
}


//analyze header
if(!in_stream.atEnd() && headeryes==1) 
{
  Header = in_stream.readLine();
  list1=Header.split(Delim);
  
   for(i=0; i<list1.size(); i++)
   {
     if(list1.at(i).contains("pos", Qt::CaseInsensitive)){poscolumn=i+1; break;}
     else poscolumn=-1;
   }
  
   for(i=0; i<list1.size(); i++)
   {
     if(list1.at(i).contains("pval", Qt::CaseInsensitive)){column=i+1; break;}
     else if(list1.at(i).contains("p-val", Qt::CaseInsensitive)){column=i+1; break;}
     else if(list1.at(i) == "P" || list1.at(i) == "p"){column=i+1; break;}
     else column=-1;
   }
   
   for(i=0; i<list1.size(); i++)
   {
     if(list1.at(i).contains("chr", Qt::CaseInsensitive)){idcolumn=i+1; break;}
     else if(list1.at(i).contains("some", Qt::CaseInsensitive)){idcolumn=i+1; break;}
     else if(list1.at(i).contains("id", Qt::CaseInsensitive)){idcolumn=i+1; break;}
     else idcolumn=-1;
   }
   
   
   if(poscolumn<1 || column<1 || idcolumn<1) {error_stream <<"Incorrect data columns!"<<"\n"; exit(1);}
   
}
else {idcolumn=1; poscolumn=2; column=3;}


QString odID="", ID, Value, Pos;
QStringList ID_list; 
Value_list.clear(); Pos_list.clear();

//read values
int readok=1;
QString Selected_Chromosome = Tag.at(selected_chromosome);
error_stream << "selected chromosome by getManhattan " << Selected_Chromosome << "\n";

while(!in_stream.atEnd() && readok)
{
oneRow = in_stream.readLine(); 


if(!oneRow.isEmpty())
{
  list1=oneRow.split(Delim); ID=list1.at(idcolumn-1); Value=list1.at(column-1); Pos=list1.at(poscolumn-1);
  
  if(oldID==Selected_Chromosome && ID!=Selected_Chromosome) readok=0; //terminate if chromosome ends, needed for speed
  
  oldID=ID;
  
  if(Value!=Missing && readok && ID==Selected_Chromosome)
  {
    value = Value.toDouble(&ok); if(!ok) {error_stream <<"Non-numeric p-value detected!"<<"\n"; exit(1);}
    if(value!=0.0)
    {

         value=-log10(value); 
	 Value_list.append(value);
                 pos=Pos.toInt(&ok); if(!ok) {error_stream <<"Non-integer position value detected!"<<"\n"; exit(1);}
		 Pos_list.append(pos);
        
    }
  }
  
}
}



if(Pos_list.size()<2) {error_stream <<"Illegal data range in getManhattan!"<<"\n"; exit(1);}

Pos_list2=Pos_list;
Value_list2=Value_list;

}

/////////////////////////////////////////////////////////////////////////
void MyWidget::getFilename()//allows to select filename and makes a list of all files in the current folder
{    
  errorfile.setFileName("Cropper_log.txt"); 
  if(!errorfile.open(QIODevice::WriteOnly | QIODevice::Text)) {exit(1);}
  error_stream.setDevice(&errorfile);
  
  error_stream <<"Cropper 0.1 by Toomas Haller"<<"\n\n";
  
      filenametext = QFileDialog::getOpenFileName(this,
                     tr("Welcome to  CROPPER !  Select File"), lastDir.absolutePath(), 
                     tr("Image Files (*.txt *.csv)"));           
                                
      if(!filenametext.isEmpty()){ lastDir = QFileInfo(filenametext).absoluteDir();}
                                  
      if(filenametext=="\0" && !list.size()) {error_stream <<"Input file problem!"<<"\n"; exit(1);}
      else if(filenametext=="\0" && list.size()) return;
         else {
              list = QStringList();
              }    

      strncpy(filename, filenametext.toLocal8Bit().constData(), 200);
 
                                                    
           if (strcmp(filename,"\0")!=0)
           {           
                      
                   QFileInfo fileInfo(filenametext);
                   QDir path = fileInfo.absoluteDir();
                       
                   QString fname = fileInfo.fileName();
                   strncpy(shortname, fname.toLocal8Bit().constData(), 30);
                   QDir dir(path);
                   
                   dir.setNameFilters( QStringList() << "*.txt" << "*.csv"); 
                 
                   QFileInfoList fiList( dir.entryInfoList( QDir::Files, QDir::Name ) ); 
                   foreach( const QFileInfo & fi, fiList ) {list << fi.absoluteFilePath();}        
                                                               
                   for (int i =0; i <list.size(); i++)
                   {if (strcmp(filename, list[i].toLocal8Bit().constData())==0) {file_index=i; break;}}
                   click_times = 0;
                            
                     QString nextPrev; 
                     if (list.size()<2)
                          {
	                      stepOK = 0;
                          }
                          
                     else {
	                       stepOK = 1;
                          }
                         
                        
                      Tag.clear(); Start_index.clear(); End_index.clear(); Start_value.clear(); End_value.clear(); Color_value.clear();

		      getManhattan0();
 
		      if(Tag.size()==1)
		      {
	              selected_chromosome=0;
		      displayLocal();
		      getManhattan();
		      getParameters();
		      reloadPhoto();
		      }
		      
		      else
		      {
	              globaldisplay=1; 
		      getParameters();
		      reloadPhoto0();
		      }      
             }
} 


////////////////////////////////////////////////////////////////////////////////////////////
void MyWidget::reloadPhoto0()//load photo0
{          
           pm_orig.scaled(fwidth,fheight);
   
           globalmap=plot0(Pos_list, Value_list, Pos_list.size());
                                                           
           fileLabel->setText(shortname);
	   displayGlobal();
}

////////////////////////////////////////////////////////////////////////////////////////////
void MyWidget::reloadPhoto()//load photo
{          
           displayLocal();
           pm_orig.scaled(fwidth,fheight);
	   pm_orig = plot(Pos_list, Value_list, Pos_list.size());

	   original_image = pm_orig.toImage();
	   pixmapLabel->setPixmap(pm_orig);
                                                                     
           fileLabel->setText(shortname);
}

/////////////////////////////////////////////////////////////////////////////////////
void MyWidget::copyAndPaste()//select rectange with mouse and crop
{
    
    QList<int> Pos_list3; QList<double> Value_list3;
    int pos1, pos2;
    
    pos1=(int)((double)origin.x()/pixPerX)+minX;
    pos2=(int)((double)myPoint.x()/pixPerX)+minX; 
    double val1 = ((double)(fheight-ymargin-origin.y())/pixPerY)+minY;
    double val2 = ((double)(fheight-ymargin-myPoint.y())/pixPerY)+minY;
    
    if(pos1>pos2){int temp; temp=pos1; pos1=pos2; pos2=temp;}
    if(val1>val2){double temp; temp=val1; val1=val2; val2=temp;}

    for(int i=0; i<Pos_list.size(); i++)
    {
      if(Pos_list.at(i)>=pos1 && Pos_list.at(i)<=pos2 && Value_list.at(i)>=val1 && Value_list.at(i)<=val2)
         { 
	   Pos_list3.append(Pos_list.at(i)); Value_list3.append(Value_list.at(i));
	 }
    }

   Pos_list.clear(); Value_list.clear();
   Pos_list=Pos_list3; Value_list=Value_list3;
   Pos_list3.clear(); Value_list3.clear();
   
   getParameters();
   reloadPhoto();

   rubberBand->hide();
}


/////////////////////////////////////////////////////////////////////////////////////
void MyWidget::selectChromosome()//select rectange with mouse and crop
{
    int i;

    pixPerX = GLOBAL_pixPerX;
    pixPerY = GLOBAL_pixPerY;
    minX = GLOBAL_minX;
    maxX = GLOBAL_maxX;
    
    int point = (origin.x() + myPoint.x()) / 2;
    int position = (int)((double)point/pixPerX)+minX;
    
    int chrom_loc=0;
    for(i=0; i<Start_value.size(); i++)
    {
      if(position>=Start_value.at(i) && position<=End_value.at(i)) {chrom_loc=i; break;}
    }
    
    selected_chromosome=chrom_loc;
    
    error_stream << "select chrom " << Tag.at(chrom_loc) << " " << chrom_loc << " point " << point << " position " << position << " start " << Start_value.at(chrom_loc)<< " end "<< End_value.at(chrom_loc) << " pixPerX " << pixPerX << " minX "<< minX << "\n\n";
    
    getManhattan();
    getParameters();
    reloadPhoto();  
    rubberBand->hide();
}


///////////////////////////////////////////////////////////////////////
void MyWidget::getParameters()//parameters for new image
{
  int i;
  int x1 = Pos_list.at(0);
  int xN = Pos_list.at(Pos_list.size()-1);
  minX=x1; maxX=xN;
  minY=9999999.9; maxY=-9999999.9;
  
  for(i=0; i<Pos_list.size(); i++)
  {
  double value = Value_list.at(i);
  if(value<minY) minY=value; if(value>maxY) maxY=value;
  }
  realMaxY=maxY;  
  realMinX=minX; realMaxX=maxX;
  
  int marX=(int)((double)(maxX-minX)*0.05);
  double marY=(maxY-minY)*0.05;
  minY-=marY;
  maxY+=marY;
  minX-=marX;
  maxX+=marX;

  fwidth = (int)(ekraan.width()*0.8); fheight = (int)(ekraan.height()*0.75);//dynamic
  
  xmargin=0; xmargin2=0; ymargin=0;

  pixPerX=((double)(fwidth-(xmargin+xmargin2)))/((double)(maxX-minX));
  pixPerY=((double)(fheight-(2*ymargin)))/(maxY-minY);
  
  globaltimes+=1;
  if(globaldisplay==1 && globaltimes==1)
  {
   error_stream << "Get GLOBAL\n";
    
   GLOBAL_minX = minX;
   GLOBAL_maxX = maxX;
   GLOBAL_pixPerX = pixPerX;
   GLOBAL_pixPerY = pixPerY;
  }
  
}

////////////////////////////////////////////////////////////////////////////////////////////
void MyWidget::showRemaining()//what is left after cropping
{          

Pos_list=Pos_list2; Value_list=Value_list2;
getParameters();
reloadPhoto();
}

////////////////////////////////////////////////////////////////////////////////////////////
void MyWidget::removeSelection()//what is left after cropping
{

if(minX < 0) return;
int i;
    
getParameters(); 
Pos_list.clear(); Value_list.clear();

for(i=0; i<Pos_list2.size(); i++)
{
  if(Pos_list2.at(i)>= minX && Pos_list2.at(i)<=maxX && Value_list2.at(i)>=minY && Value_list2.at(i)<=maxY)
  {
    ;
  }
  else
  {
    Pos_list.append(Pos_list2.at(i)); Value_list.append(Value_list2.at(i));
  }
}

Pos_list2.clear(); Value_list2.clear();
Pos_list2 = Pos_list; Value_list2 = Value_list;

getParameters();
reloadPhoto();
}

//////////////////////////////////////////////////////////////////////////////////////

void MyWidget::checkBox1Action()
{

 if(checkBox1->checkState()==0) line=0;
 if(checkBox1->checkState()==2) line=1;
 reloadPhoto();

}

//////////////////////////////////////////////////////////////////////////////////////

void MyWidget::checkBox2Action()
{
 
 if(checkBox2->checkState()==0) stripes=0;
 if(checkBox2->checkState()==2) stripes=1;
 reloadPhoto();

}

//////////////////////////////////////
void MyWidget::saveAndRemove()
{
 if(minX < 0) return;
 
  if(globaldisplay==1)
  {
    
    QString Shortname = shortname;
    Shortname += ".png";
    globalmap.save(Shortname, 0, -1);
  }
  
  else
  {  
  bool ok = makeFile();
  if(ok) removeSelection();
  }
  
}

/////////////////////////////////////
void MyWidget::Save()
{
  if(globaldisplay==1)
  {
    
    QString Shortname = shortname;
    Shortname += ".png";
    globalmap.save(Shortname, 0, -1);
  }
  
  else makeFile();

}


//////////////////////////////////////
void MyWidget::displayGlobal()
{
  if(Tag.size()>1)
  {
  pixmapLabel->setPixmap(globalmap);
  globaldisplay=1;
  checkBox1->hide(); 
  checkBox2->hide();
  globalFileButton->hide();
  remainingButton->hide();
  removeButton->hide();
  //fileButton->hide();
  removeButton2->hide();
  startEdit->hide();
  endEdit->hide();
  textLabel->setText("HINT: Draw a box in or around a chromosome to select an entire chromsome");
  }

}

//////////////////////////////////////
void MyWidget::displayLocal()
{

  globaldisplay=0;
  checkBox1->show(); 
  checkBox2->show();
  globalFileButton->show();
  remainingButton->show();
  removeButton->show();
  removeButton2->show();
  startEdit->show();
  endEdit->show();
  textLabel->setText("");
  
}
